package mscJNeuralNet.gui;

import java.awt.Color;
import java.awt.GridLayout;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JPanel;

import mscJNeuralNet.gui.subComponents.JLabeledTextField;
import mscJNeuralNet.net.Net;

/**
 * Grafische Komponente zur Darstellung einfacher Informationen ber das Netz.<br/>
 * Es werden folgende Informationen ber das Netz angezeigt: xxxx<p/>
 * <img src="../../images/jnetinfoview.gif"><p/>
 * 
 * Created on 09.06.2004
 * @author <A HREF="http://www.graviton.de">M. Serhat Cinar</A>
 * @version 09.06.2004
 */
public class JNetInfoView extends JPanel{
	private static final ResourceBundle smMSCResourceBundle = ResourceBundle.getBundle("mscJNeuronalNet_Text");
	
	private Net mNet;
	private JLabeledTextField mLTfInputLayerSize;
	private JLabeledTextField mLTfHiddenLayerSizes[];
	private JLabeledTextField mLTfOutputLayerSize;
	private JLabeledTextField mLTfTransfer;
	private JPanel mPInner;
	
	public JNetInfoView(){
		super();
		setBorder(
			BorderFactory.createTitledBorder(
				BorderFactory.createLineBorder(Color.BLACK),
				smMSCResourceBundle.getString("NET_INFO")
			)
		);

		mLTfInputLayerSize = new JLabeledTextField(3);
		mLTfInputLayerSize.getLabel().setText(smMSCResourceBundle.getString("INPUT_NEURONS")+":");
		mLTfInputLayerSize.getTextField().setEditable(false);
		
		mLTfOutputLayerSize = new JLabeledTextField(3);
		mLTfOutputLayerSize.getLabel().setText(smMSCResourceBundle.getString("OUTPUT_NEURONS")+":");
		mLTfOutputLayerSize.getTextField().setEditable(false);
		
		mLTfTransfer = new JLabeledTextField(4);
		mLTfTransfer.getLabel().setText(smMSCResourceBundle.getString("TRANSFERFUNCTION")+":");
		mLTfTransfer.getTextField().setEditable(false);
		
		mPInner = new JPanel();
		add(mPInner);
	}
	
	public void setNet(Net pNet){
		mNet = pNet;
		updateView();
	}
	
	public Net getNet(){
		return mNet;
	}
	
	private void updateView(){
		mPInner.removeAll();
		mPInner.setLayout(new GridLayout(mNet.getLayerNeurons().length+1, 1));
		mLTfInputLayerSize.getTextField().setText(mNet.getInputLayerSize()+"");
		mPInner.add(mLTfInputLayerSize);
		mLTfHiddenLayerSizes = new JLabeledTextField[mNet.getHiddenLayerAmount()];
		for (int i=0; i<mNet.getHiddenLayerAmount(); i++){
			mLTfHiddenLayerSizes[i] = new JLabeledTextField(3);
			mLTfHiddenLayerSizes[i].getTextField().setEditable(false);
			mLTfHiddenLayerSizes[i].getLabel().setText(smMSCResourceBundle.getString("HIDDEN_NEURONS")+" "+(i+1)+":");
			mLTfHiddenLayerSizes[i].getTextField().setText(Integer.toString(mNet.getLayerNeurons()[1+i].length));
			mPInner.add(mLTfHiddenLayerSizes[i]);
		}
		mLTfOutputLayerSize.getTextField().setText(Integer.toString(mNet.getOutputLayerSize()));
		mPInner.add(mLTfOutputLayerSize);
		mLTfTransfer.getTextField().setText("Tanh");
		mPInner.add(mLTfTransfer);
		updateUI();
	}
}
