package mscJNeuralNet.gui;

import java.awt.Color;
import java.awt.GridLayout;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import mscJNeuralNet.gui.subComponents.JWeightView;
import mscJNeuralNet.net.Net;

/**
 * Grafische Komponente zur Darstellung der Gewichtswerte und der Gewichtsstruktur
 * eines Netzes.<p/>
 * <img src="../../images/jnetweightview.gif"><p/>
 * 
 * Created on 09.06.2004
 * @author <A HREF="http://www.graviton.de">M. Serhat Cinar</A>
 * @version 26.06.2004
 */
public class JNetWeightView extends JPanel{
	private static final ResourceBundle smMSCResourceBundle = ResourceBundle.getBundle("mscJNeuronalNet_Text");

	private JWeightView mPContent;
	private JScrollPane mScrollPane;
	
	public JNetWeightView(){
		super();
		setBorder(
			BorderFactory.createTitledBorder(
				BorderFactory.createLineBorder(Color.BLACK),
				smMSCResourceBundle.getString("WEIGHT_STRUCTURE")
			)
		);
		// setLayout(new FlowLayout());
		setLayout(new GridLayout(1,1));
		
		mPContent = new JWeightView();
		mScrollPane = new JScrollPane(mPContent);
		mScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		mScrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		// mScrollPane.setPreferredSize(new Dimension(400, 200));
		add(mScrollPane);
	}
	
	public void setNet(Net pNet){
		mPContent.setNet(pNet);
	}
	
	public Net getNet(){
		return mPContent.getNet();
	}
}
