package mscJNeuralNet.trainingAlgorithms;

import observerPattern.ObserverManager;
import mscJNeuralNet.net.Net;

/**
 * Diese abstrakte Klasse implementiert Teile
 * der Schnittstelle {@link mscJNeuralNet.trainingAlgorithms.INetTrainingAlgorithm}
 * und sollte als Grundlage fr die Implementierung eigener Lernverfahren dienen.
 * <p/>
 * Created on 02.06.2004
 * @author <A HREF="http://www.graviton.de">M. Serhat Cinar</A>
 * @version 05.06.2004
 * @see mscJNeuralNet.trainingAlgorithms.INetTrainingAlgorithm
 * @see mscJNeuralNet.trainingAlgorithms
 */
public abstract class AbstractTrainingAlgorithm
	implements INetTrainingAlgorithm{
	
	private Net mNet = null;
	private int mCycle = 0;
	private double [][] mGradients; 
	
	
	/**
	 * Derzeit leer.
	 * 
	 * @see mscJNeuralNet.trainingAlgorithms.INetTrainingAlgorithm#init()
	 */
	public void init(){/** leer */}
	
	/* (non-Javadoc)
	 * @see mscJNeuralNet.trainingAlgorithms.INetTrainingAlgorithm#setNet(mscJNeuralNet.net.Net)
	 */
	public void setNet(Net pNet){
		mNet = pNet;
		init();
	}
	
	/* (non-Javadoc)
	 * @see mscJNeuralNet.trainingAlgorithms.INetTrainingAlgorithm#getNet()
	 */
	public Net getNet(){
		return mNet;
	}
	
	/**
	 * Am Ende dieser Methode werden alle Observer benachrichtigt.
	 * 
	 * @see mscJNeuralNet.trainingAlgorithms.INetTrainingAlgorithm#setCycle(int)
	 */
	public void setCycle(int pCycle){	
		mCycle = pCycle;
		mObserverManager.notifyObservers(this);
	}
	
	/* (non-Javadoc)
	 * @see mscJNeuralNet.trainingAlgorithms.INetTrainingAlgorithm#getCycle()
	 */
	public int getCycle(){	return mCycle;}
	
	/* (non-Javadoc)
	 * @see mscJNeuralNet.trainingAlgorithms.INetTrainingAlgorithm#setActualGradients(double[][])
	 */
	public void setActualGradients(double[][] pGradients){
		mGradients = pGradients;
	}
	
	/* (non-Javadoc)
	 * @see mscJNeuralNet.trainingAlgorithms.INetTrainingAlgorithm#getActualGradients()
	 */
	public double[][] getActualGradients(){
		return mGradients;
	}
	
	/**
	 * Derzeit leer.
	 * 
	 * @see mscJNeuralNet.trainingAlgorithms.INetTrainingAlgorithm#applyWeightUpdate(int, int)
	 */
	public void applyWeightUpdate(int pOutputting, int pInputting){/* leer */}
	
	private ObserverManager mObserverManager = new ObserverManager();
	
	/* (non-Javadoc)
	 * @see observerPattern.Observable#getObserverManager()
	 */
	public ObserverManager getObserverManager(){
		return mObserverManager;
	}	
}
